#!/usr/bin/env python
# encoding: utf-8
#
# ** header v3.0
# This file is a part of the CaosDB Project.
#
# Copyright (C) 2018 Research Group Biomedical Physics,
# Max-Planck-Institute for Dynamics and Self-Organization Göttingen
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#
# ** end header
#
"""does something"""


import caosdb as db


class Crawler(object):
    def __init__(self, food):
        self.food = food
        self.report = db.Container()

    def crawl(self, files):
        for crawled_file in files:
            # if crawled_file.size == 0:
            #    crawled_file.add_message(
            #        type="Warning", description="This file is empty. Shouldn't we delete it?")
            #    self.report.append(crawled_file)

            #    continue

            for cfood in self.food:
                match = cfood.pattern.match(crawled_file.path)

                if match is not None:
                    cfood.treat_match(crawled_file, match)

    @staticmethod
    def query_files(path):
        query_str = "FIND FILE WHICH IS STORED AT " + \
            (path if path.endswith("/") else path + "/") + "**"
        print("FILES QUERY: " + query_str)
        files = db.execute_query(query_str)
        print(str(len(files)) + " FILES TO BE PROCESSED.")

        return files


