#!/usr/bin/env python
# encoding: utf-8
#
# ** header v3.0
# This file is a part of the CaosDB Project.
#
# Copyright (C) 2018 Research Group Biomedical Physics,
# Max-Planck-Institute for Dynamics and Self-Organization Göttingen
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#
# ** end header
import unittest
from tempfile import NamedTemporaryFile

import caosdb as db
from caosadvancedtools.cfood import AbstractCFood

# TODO this is more like an integration test. should be moved


class CFoodTest(unittest.TestCase):
    def setUp(self):
        self.exp = db.Record()
        self.exp.add_parent(name="Experiment")
        self.exp.add_property(name="species", value="microunicorn")

    def test_check_existence(self):
        assert AbstractCFood.find_existing(self.exp) is None

class CFoodTestExist(CFoodTest):
    def setUp(self):
        super().setUp()
        self.exp.insert()

    def test_check_existence(self):
        res = AbstractCFood.find_existing(self.exp)
        assert  res.id == self.exp.id

    def tearDown(self):
        self.exp.delete()
